"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var baseNodeMixin_1 = require("../mixins/baseNodeMixin");
var geometryMixin_1 = require("../mixins/geometryMixin");
var layoutMixin_1 = require("../mixins/layoutMixin");
var saveStyleMixin_1 = require("../mixins/saveStyleMixin");
var propsAssign_1 = require("../helpers/propsAssign");
var refMixin_1 = require("../mixins/refMixin");
var textNodeProps = [
    'textAlignHorizontal',
    'textAlignVertical',
    'textAlignVertical',
    'textAutoResize',
    'paragraphIndent',
    'paragraphSpacing',
    'autoRename',
    'fontSize',
    'fontName',
    'textCase',
    'textDecoration',
    'letterSpacing',
    'lineHeight'
];
var textNodePropsAssign = propsAssign_1.propsAssign(textNodeProps);
exports.text = function (node) { return function (props) {
    var textNode = node || figma.createText();
    refMixin_1.refMixin(textNode)(props);
    baseNodeMixin_1.baseNodeMixin(textNode)(props);
    saveStyleMixin_1.saveStyleMixin(textNode)(props);
    layoutMixin_1.layoutMixin(textNode)(props);
    geometryMixin_1.geometryMixin(textNode)(props);
    var fontName = textNode.fontName;
    if (typeof fontName !== 'object') {
        fontName = {
            family: 'Roboto',
            style: 'Regular'
        };
    }
    //figma.loadFontAsync(fontName);
    textNode.characters = props.characters;
    textNodePropsAssign(textNode)(props);
    return textNode;
}; };
//# sourceMappingURL=text.js.map